#!/usr/bin/python

from ubot.helper import UbotResponder, UbotCommander, main
from ubot.rfc2812 import IrcString
import os, random, shelve

class LartResponder(UbotCommander,UbotResponder):
    commands = {IrcString('lart'): 'lart',
                IrcString('slander'): 'lart',
                IrcString('pity'): 'lart'}

    def add_options(self, parser):
        super(LartResponder, self).add_options(parser)
        parser.add_option('-l', '--larts', dest='lartdb', default='', help='File containing the larts', metavar='FILE')

    def init(self, **kwargs):
        super(LartResponder, self).init(**kwargs)
        self.larts = open(kwargs['lartdb']).read().splitlines()

    def lart(self, prefix, target, params, ltarget):
        if not ltarget.strip() or ltarget == 'me' or 'self' in ltarget:
            ltarget = prefix[:prefix.find('!')]
        if self.nickname in ltarget or IrcString('Seveas') in ltarget:
            ltarget = prefix[:prefix.find('!')]
        if random.random() > 0.75 and IrcString('ubuntu/member/seveas') not in prefix:
            ltarget = prefix[:prefix.find('!')]
        self.reply(random.choice(self.larts).replace('$who', ltarget), action=True, slow=True)

if __name__ == '__main__':
    main(LartResponder)
