#!/usr/bin/python

import commands, os, random, re, sys, thread, traceback, urllib2
from ubot.helper import UbotResponder, UbotCommander, main
from ubot.rfc2812 import IrcString as S

class MessResponder(UbotCommander,UbotResponder):
    commands = {
        S('t'):           ['http://4q.cc/?pid=fact&person=mrt',      r'<div id="factbox">\s*(?P<fact>.*?)\s*</div>', False], 
        S('chuck'):       ['http://4q.cc/?pid=fact&person=chuck',    r'<div id="factbox">\s*(?P<fact>.*?)\s*</div>', False], 
        S('vin'):         ['http://4q.cc/?pid=fact&person=vin',      r'<div id="factbox">\s*(?P<fact>.*?)\s*</div>', False], 
        S('bauer'):       ['http://www.notrly.com/jackbauer/',       r'<p class="fact">(?P<fact>.*?)</p>',           False], 
        S('bruce'):       ['http://geekz.co.uk/schneierfacts/',      r'p class="fact">(?P<fact>.*?)</p',             False], 
        S('esr'):         ['http://geekz.co.uk/esrfacts/',           r'p class="fact">(?P<fact>.*?)</p',             False], 
        S('mcgyver'):     ['http://www.macgyver.co.za/',             r'wishtable">\s*(?P<fact>.*?)<div',             False], 
        S('macgyver'):    ['http://www.macgyver.co.za/',             r'wishtable">\s*(?P<fact>.*?)<div',             False], 
        S('hamster'):     ['http://hamsterrepublic.com/dyn/bobsez',  r'<font.*?<b>\s*(?P<fact>.*?)</font>',          False], 
        S('bush'):        ['http://www.dubyaspeak.com/random.phtml', r'(?P<fact><font.*</font>)',                    True],
        S('mjg'):         ['http://www.angryfacts.com',              r'</p><h1>(?P<fact>.*?)</h1>',                  False], 
        S('mjg59'):       ['http://www.angryfacts.com',              r'</p><h1>(?P<fact>.*?)</h1>',                  False], 
        S('vmjg'):        ['http://www.rjek.com/vmjg59.cgi',         r'<body>(?P<fact>.*?)<p>',                      True],
        S('vmjg59'):      ['http://www.rjek.com/vmjg59.cgi',         r'<body>(?P<fact>.*?)<p>',                      True],
        S('shakespeare'): ['http://www.pangloss.com/seidel/Shaker/', r'<font.*?>(?P<fact>.*?)</font>',               False], 
        S('lugradio'):    ['http://planet.lugradio.org/facts/',      r'<h2>\s*(?P<fact>.*?)</h2>',                   False], 
        S('limerick'):    ['http://limerickdb.com/?random2',         r'<div class="quote_output">\s*(?P<fact>.*?)\s*</div', False], 

        S('bofh'):        ['bofh.txt',    'BOFH Excuse of the day: ',    False], 
        S('42'):          ['42.txt',      '',                            False], 
        S('magic8ball'):  ['ball.txt',    '',                            False], 
        S('ferengi'):     ['ferengi.txt', 'Ferengi rule of acquisition', False],
        S('ralph'):       ['ralph.txt',   '',                            False],

        S('dice'):        ['dice',     False],
        S('fortune'):     ['fortune',  False],
        S('ofortune'):    ['ofortune', True],
        S('futurama'):    ['futurama', False],
        S('pony'):        ['pony',     False],
        S('hug'):         ['hug',      False],
    }

    def add_options(self, parser):
        super(MessResponder, self).add_options(parser)
        parser.add_option('-o', '--ochannels', dest='ochannels', default='', help="Channels where hairy responses are ok", metavar="CHANNELS")
        parser.add_option('-d', '--data', dest='datadir', default=os.path.expanduser('~/.ubot/data'), 
                          help="Directory where textfiles live", metavar="DIR")

    def init(self, **kwargs):
        super(MessResponder, self).init(**kwargs)
        self.ochannels = kwargs['ochannels'].split(',')
        self.datadir = kwargs['datadir']
        for c in self.commands:
            if len(self.commands[c]) != 3:
                continue
            if self.commands[c][0].startswith('http'):
                self.commands[c][1] = re.compile(self.commands[c][1], re.I|re.DOTALL)
            else:
                fd = open(os.path.join(self.datadir, self.commands[c][0]))
                self.commands[c][0] = fd.read().splitlines()
                fd.close()
        self.hugs = open(os.path.join(self.datadir, 'hugs.txt')).read().splitlines()

    def addressed(self, prefix, target, msg):
        if S('hug') in msg and self.nickname in msg:
            self._UbotCommander__lastcommand[thread.get_ident()] = 'hug'
            self._UbotCommander__lastargument[thread.get_ident()] = prefix[:prefix.find('!')]
            return True
        return super(MessResponder, self).addressed(prefix, target, msg)

    def in_privmsg(self, prefix, target, params):
        if not self.addressed(prefix, target, params[0]):
            return
        cmd = self._UbotCommander__lastcommand[thread.get_ident()]
        if self.commands[cmd][-1] and target not in self.ochannels:
            return
        if len(self.commands[cmd]) == 2:
            func = getattr(self, self.commands[cmd][0])
            if func.func_code.co_argcount == 2:
                func(self._UbotCommander__lastargument[thread.get_ident()])
            else:
                func()
            return
        source, ext = self.commands[cmd][:2]
        if type(source) == list:
            self.reply(ext + random.choice(source), slow=True)
            return
        for i in range(5):
            try:
                inp = urllib2.urlopen(source).read()
                out = ext.search(inp).group('fact')
            except Exception, e:
                self.log("Failed to download/parse %s" % source)
                break
            out = filter(out, target in self.ochannels)
            if out:
                self.reply(out, slow=True)
                break

    def dice(self, count): 
        """Roll a number of dice"""
        try:
            count = int(count)
        except:
            count = 5
        count = min(5,max(1,count))
        self.reply(u' '.join([x.__call__([u"\u2680",u"\u2681",u"\u2682",u"\u2683",u"\u2684",u"\u2685"])
                             for x in [random.choice]*count]), slow=True)

    def pony(self, who):
        """Can we have a pony?"""
        if not who:
            who = 'you'
        self.reply("No, %s can't have a pony!" % (who.strip(),))

    def fortune(self, offensive=False):
        """Display fortune cookies"""
        arg = offensive and '-so' or '-s'
        for l in commands.getoutput('/usr/games/fortune ' + arg).splitlines():
            self.reply(l, slow=True)

    def ofortune(self):
        """Display (possibly offensive) fortune cookies"""
        self.fortune(True)

    def futurama(self):
        """Futurama quotes from slashdots HTTP headers"""
        u = urllib2.urlopen('http://slashdot.org')
        h = [x for x in u.headers.headers if x.startswith('X') and not x.startswith('X-Powered-By')][0]
        self.reply(h[2:].strip().replace(' ',' "',1) + '"', slow=True)

    def hug(self, who):
        """Give someone a hug"""
        self.reply(random.choice(self.hugs).replace('$who',who), action=True)

# Rudimentary badwords filter and html cleanup
badwords = ['sex','masturbate','fuck','rape','dick','pussy','prostitute','hooker',
            'orgasm','sperm','cunt','penis','shit','piss','urin','bitch','semen','cock',
            'retard', 'cancer', 'hiv', 'aids', 'ass', 'tit']
tagre = re.compile(r'<.*?>')
def filter(txt, off):
    _txt = txt.lower()
    if not off:
        for b in badwords:
            if b in _txt:
                return None
    txt = txt.replace('<br />',' ')
    txt = txt.replace('<i>','/').replace('</i>','/').replace('<b>','*').replace('</b>','*')
    txt = txt.replace('&quot;','"').replace('&lt;','<').replace('&gt;','>')
    txt = tagre.sub('',txt)
    txt = re.sub('\s+',' ',txt)
    return txt

if __name__ == '__main__':
    main(MessResponder)
