#!/usr/bin/python

import dbus, optparse, os
import ubot.util

parser = optparse.OptionParser()
parser.add_option('-H', '--host',
                  dest='host',
                  default='localhost',
                  help='The host your ubot is running on')
parser.add_option('-p', '--port', 
                  dest='port',
                  default=11235,
                  type=int,
                  help='The port dbus-daemon listens on')
parser.add_option('-n', '--name',
                   dest='dbus_name', 
                   default='ubot',
                   help='The busname of your bot')
parser.add_option('-c', '--channel', 
                  dest='channel',
                  help='The channel to send to',
                  default=None)

opts, args = parser.parse_args()

os.environ['DBUS_SESSION_BUS_ADDRESS'] = 'tcp:host=%s,port=%d' % (opts.host, opts.port)

bus = dbus.SessionBus()
command = args[0]
args = args[1:]
if not opts.channel:
    bot = bus.get_object('net.seveas.ubot.' + opts.dbus_name, 
                         '/net/seveas/ubot/' + opts.dbus_name)
    print "Calling %s with arguments %s" % (command, unicode(args))
    if command != 'rawmsg':
        print getattr(bot, command)(*args, **{'dbus_interface': 'net.seveas.ubot'})
    else:
        print getattr(bot, command)(args[0], args[1:], **{'dbus_interface': 'net.seveas.ubot'})
else:
    chan = bus.get_object('net.seveas.ubot.' + opts.dbus_name, 
                          '/net/seveas/ubot/%s/channel/%s' % (opts.dbus_name, ubot.util.escape_object_path(opts.channel)))
    print "Calling %s on %s with arguments %s" % (command, opts.channel, unicode(args))
    print getattr(chan, command)(*args, **{'dbus_interface': 'net.seveas.ubot.channel'})
