#!/usr/bin/python

import ubot.bot
import ubot.conf
import optparse, os

parser = optparse.OptionParser()
parser.add_option('-H', '--host',
                  dest='host',
                  default='localhost',
                  help='The host your ubot is running on')
parser.add_option('-p', '--port', 
                  dest='port',
                  default=11235,
                  type=int,
                  help='The port dbus-daemon listens on')
parser.add_option('-c', '--config',
                  dest='config',
                  default=os.path.expanduser('~/.ubot/config'),
                  help="Specify configfile",
                  metavar="FILE")
parser.add_option('-v', '--verbose',
                  dest='verbose',
                  action='count',
                  default=0,
                  help='Print all messages. Use twice to see raw messages as well')
opts, args = parser.parse_args()
if args:
    parser.error("No arguments allowed")

os.environ['DBUS_SESSION_BUS_ADDRESS'] = 'tcp:host=%s,port=%d' % (opts.host, opts.port)

bot = ubot.bot.Ubot(ubot.conf.UbotConfig(opts.config))
bot.verbose = opts.verbose
bot.run()
