import datetime, pytz
from django.shortcuts import render_to_response
from django.template import RequestContext

blacklist = ('US/Pacific-New',)
zones = [pytz.timezone(x) for x in pytz.common_timezones if x not in blacklist]

def timezones(request):
    now = datetime.datetime.now(pytz.UTC)
    for z in zones:
        z.now  = now.astimezone(z)
        z.offset = z.now.strftime("%z")
    return render_to_response('timezones.html', {'zones': zones, 'now': now}, context_instance=RequestContext(request))
