/* Load and update bot info */
loadBotInfo = function(repeat) {
    d = loadJSONDoc('/control/rpc/info/');
    d.addCallback(function(data){showBotInfo(data, repeat);});
}
showBotInfo = function(info, repeat) {
    replaceChildNodes("synced", info[0] ? SPAN({'style': 'color:green'}, "YES") :
                                          SPAN({'style': 'color:red'}, "NO"));
    replaceChildNodes("master", info[1] ? SPAN({'style': 'color:green'}, "YES") :
                                          SPAN({'style': 'color:red'}, "NO"));
    replaceChildNodes("nickname", info[2]);
    if(repeat) {
        callLater(30, loadBotInfo, true);
    }
}
addLoadEvent(function(){loadBotInfo(true);});

/* Load and update channel info */
loadChannels = function(repeat) {
    d = loadJSONDoc('/control/rpc/channels/');
    d.addCallback(function(data){showChannels(data, repeat);});
}
showChannels = function(channels, repeat) {
    var laststyle = 'even';
    chan_display = function(chan) {
        partbutton = function(chan) {
            b = INPUT({'type': 'button', 'value': 'part'});
            connect(b, "onclick", function(event) { partChannel(chan); });
            return b;
        }
        laststyle = (laststyle == 'even' ? 'odd' : 'even');
        return TR({'class': laststyle}, 
                    TD(null, chan.name, BR(), partbutton(chan.name)),
                    TD(null, chan.mode),
                    TD(null, chan.topic),
                    TD(null, chan.nicks.length));
    }
    e = $("channels");
    while((c = e.firstChild)) {
        e.removeChild(c);
    }
    appendChildNodes(e, map(chan_display, channels));
    if(repeat) {
        callLater(30, loadChannels, true);
    }
}
addLoadEvent(function(){loadChannels(true);});

/* Join channel */
joinChannel = function(name) {
    name = escape(name.replace('#','')) + '/';
    d = doSimpleXMLHttpRequest('/control/rpc/join/' + name);
    d.addCallback(function(data){callLater(2, function(){loadChannels(false);}); callLater(2, function(){loadBotInfo(false);});});
    d.addErrback(function(data){alert(data);});
}
addLoadEvent(function(){connect("joinbutton", "onclick", function(event){joinChannel($("join").value);});});

/* Part channel */
partChannel = function(name) {
    name = escape(name.replace('#',''));
    d = doSimpleXMLHttpRequest('/control/rpc/channel/' + name + '/part/');
    d.addCallback(function(data){callLater(2, function(){loadChannels(false);}); callLater(2, function(){loadBotInfo(false);});});
    d.addErrback(function(data){alert(data);});
}
