import os, sys, types
root = os.path.dirname(os.path.dirname(os.path.dirname(__file__)))
sys.path.insert(0,os.path.join(root, 'helpers'))
sys.path.insert(0,root)
import mess
from django.shortcuts import render_to_response
from django.template import RequestContext
from django.contrib.auth.decorators import user_passes_test
from django.http import Http404

resp = mess.MessResponder()
commands = resp.commands
def what(src):
    if hasattr(resp, src):
        return getattr(resp, src).__doc__
    elif src.startswith('http'):
        return 'Random quotes from <a href="%s">%s</a>' % (src, src)
    else:
        return 'Random text from <a href="./%s/">%s</a>' % (src, src)
commands = [(unicode(x), what(commands[x][0])) for x in sorted(commands.keys())]

def index(request):
    return render_to_response('mess/index.html', {'commands': commands}, context_instance=RequestContext(request))

def display(request, name):
    file = os.path.join(root, 'data', 'mess', name)
    if not os.path.exists(file):
        raise Http404
    return render_to_response('mess/file.html', 
                              {'file': name, 'data': open(file).readlines(), 'editmess': request.user.is_authenticated() and editors in request.user.groups.all()}, 
                              context_instance=RequestContext(request))

# Can't use a permission since there's no content_type to link it to
from django.contrib.auth.models import Group
editors, created = Group.objects.get_or_create(name="mess editors")
@user_passes_test(lambda u: u.is_authenticated() and editors in u.groups.all())
def edit(request, name):
    file = os.path.join(root, 'data', 'mess', name)
    if not os.path.exists(file):
        raise Http404
    if request.POST:
        fd = open(file, 'w')
        fd.write(request.POST['contents'].strip().replace('\r\n','\n'))
        fd.close()
    return render_to_response('mess/editfile.html', 
                              {'file': name, 'data': open(file).read(), 'editmess': request.user.is_authenticated() and editors in request.user.groups.all()}, 
                              context_instance=RequestContext(request))
