from django.conf.urls.defaults import *
from django.http import HttpResponseRedirect
import os

def redirect(request, target):
    return HttpResponseRedirect(target)

urlpatterns = patterns('',
    # Admin interface
    (r'^admin/', include('django.contrib.admin.urls')),

    # Control interface
    (r'^control/', include('ubotweb.control.urls')),

    # Docs 
    (r'^$', 'ubotweb.urls.redirect', {'target': '/doc/home'}),
    (r'^doc/', include('ubotweb.doc.urls')),

    # Helpers
    (r'^encyclopedia/', include('ubotweb.encyclopedia.urls')),
    (r'^agenda/', include('ubotweb.agenda.urls')),
    (r'^mess/', include('ubotweb.mess.urls')),

    # Static files, for use with the development server
    (r'^site-media/(?P<path>.*)$', 'django.views.static.serve',
        {'document_root': os.path.join(os.path.dirname(__file__), 'media'),
         'show_indexes': True}),
)
